Imports System.Web
Imports System.Web.Services
Imports System.Web.Services.Protocols
Imports System.Data
Imports System.Data.OleDb

<WebService(Namespace:="http://localhost/WebSite/")> _
<WebServiceBinding(ConformsTo:=WsiProfiles.BasicProfile1_1)> _
<Global.Microsoft.VisualBasic.CompilerServices.DesignerGenerated()> _
Public Class UniversalThread
    Inherits System.Web.Services.WebService

    ' Do the login for the specific user
    <WebMethod()> _
     Public Function Login(ByVal tcUsername As String, ByVal tcPassword As String) As Boolean
        Dim lcUsername As String
        Dim lcPassword As String
        Dim loDataProvider As Data = New Data
        Dim lcConnection As String
        Dim loRow As DataRow
        Dim lcSession As String
        lcUsername = UCase(tcUsername).PadRight(10, " ")
        lcPassword = UCase(tcPassword).PadRight(10, " ")
        loDataProvider.oParameters.Add(New OleDbParameter("@Username", lcUsername))
        lcConnection = "Provider=VFPOLEDB.1;Data Source=" + _
         """d:\Visual Studio Projects\Level Extreme .NET Magazine"";Password='';Collating Sequence=MACHINE"

        ' Get the record of the user
        If loDataProvider.SQLExec("SELECT PrimaryKey,Password,Session FROM Member WHERE Username=?", lcConnection) = False Then
            Throw New System.Exception("Problem with retrieving the data: " + loDataProvider.cError)
        End If

        ' If we didn't find any record
        If loDataProvider.nCount = 0 Then
            Throw New System.Exception("This username does not exist.")
        End If

        ' Get it into a row
        loRow = loDataProvider.oDataView(0).Row

        ' If the password is not valid
        If UCase(loRow("Password")) <> lcPassword Then
            Throw New System.Exception("The password is invalid.")
            Return False
        End If

        ' Update the session and the last login time stamp
        lcSession = Guid.NewGuid.ToString()

        If loDataProvider.SQLUpdate("UPDATE Member SET Session=""" + lcSession + """" + _
        ",LastLogin=" + DateUniversal(Date.Now) + " WHERE PrimaryKey=" + loRow("PrimaryKey").ToString, lcConnection) = False Then
            Throw New System.Exception("Problem with updating the session: " + loDataProvider.cError)
            Return False
        End If

        ' Create the cookie
        System.Web.HttpContext.Current.Response.Cookies("Session").Value = lcSession

        Return True
    End Function

    ' Return the time of the server
    <WebMethod()> _
    Public Function GetTime() As String
        CheckLogin()
        Return System.DateTime.Now()
    End Function

    ' Check for the login
    Public Function CheckLogin() As Boolean
        Dim loCookie As System.Web.HttpCookie
        Dim lcSession As String
        Dim lcError As String
        Dim loDataProvider As Data = New Data
        Dim lcConnection As String
        loCookie = System.Web.HttpContext.Current.Request.Cookies("Session")
        lcError = ""
        lcConnection = "Provider=VFPOLEDB.1;Data Source=" + _
         """d:\Visual Studio Projects\Level Extreme .NET Magazine"";Password='';Collating Sequence=MACHINE"

        ' If the cookie is not found
        If loCookie Is Nothing Then
            Throw New System.Exception("You have to login in order to use the Web Service.")
        End If

        ' Get the session from the cookie
        lcSession = loCookie.Value.ToString()

        ' Get the user record
        loDataProvider.oParameters.Add(New OleDbParameter("@Session", lcSession))
        If loDataProvider.SQLExec("SELECT PrimaryKey FROM Member WHERE Session=?", lcConnection) = False Then
            Throw New System.Exception("Problem with retrieving the data: " + loDataProvider.cError)
        End If

        ' If we didn't find any record
        If loDataProvider.nCount = 0 Then
            Throw New System.Exception("This session does not exist.")
        End If

    End Function

    ' Return a date in a universal format
    ' expD1 Date
    Public Function DateUniversal(ByVal tdDate As Date) As String
        Dim lcDate As String
        Dim lnDay As Integer
        Dim lnMonth As Integer
        Dim lnYear As Integer
        Dim lnHour As Integer
        Dim lnMinute As Integer
        Dim lnSecond As Integer
        lcDate = ""
        lnDay = tdDate.Day
        lnMonth = tdDate.Month
        lnYear = tdDate.Year
        lnHour = tdDate.Hour
        lnMinute = tdDate.Minute
        lnSecond = tdDate.Second
        lcDate = lcDate + "{^"
        lcDate = lcDate + Trim(lnYear.ToString) + "/" + lnMonth.ToString.PadLeft(2, "0") + "/" + _
         lnDay.ToString.PadLeft(2, "0") + " " + lnHour.ToString.PadLeft(2, "0") + ":" + _
         lnMinute.ToString.PadLeft(2, "0") + ":" + lnSecond.ToString.PadLeft(2, "0")
        lcDate = lcDate + "}"
        Return lcDate
    End Function

End Class

Public Class Data

    Public oDataAdapter As OleDbDataAdapter
    Public oDataSet As DataSet
    Public oDataView As DataView
    Public cSQL As String
    Public cConnectionString As String
    Public nCount As Integer
    Public oParameters As New Collection
    Public cError As String

    ' SQL exec
    ' expC1 SQL command
    ' expO1 Connection
    Public Function SQLExec(ByVal tcSQL As String, ByVal tcConnection As String) As Boolean
        Dim llSuccess As Boolean
        Dim loCommand As New OleDbCommand
        Dim loParam As OleDbParameter
        llSuccess = False
        cSQL = tcSQL
        cConnectionString = tcConnection
        Try
            loCommand.Connection = New OleDbConnection(tcConnection)
            loCommand.CommandText = tcSQL

            ' Only add the parameters if we have some
            If Not oParameters Is Nothing Then
                For Each loParam In oParameters
                    loCommand.Parameters.Add(loParam)
                Next
            End If

            oDataAdapter = New OleDbDataAdapter
            oDataAdapter.SelectCommand = loCommand
            oDataSet = New DataSet
            oDataAdapter.Fill(oDataSet, "Temp")

            ' Record count
            nCount = oDataSet.Tables("Temp").Rows.Count

            ' If we have at least one record
            If nCount > 0 Then
                oDataView = New DataView
                oDataView = oDataSet.Tables("Temp").DefaultView
            End If

            llSuccess = True
        Catch loError As Exception
            cError = loError.Message
        End Try
        Return llSuccess
    End Function

    ' SQL update
    ' expC1 SQL command
    ' expO1 Connection
    Public Function SQLUpdate(ByVal tcSQL As String, ByVal tcConnection As String) As Boolean
        Dim llSuccess As Boolean
        Dim loConnection As OleDbConnection
        llSuccess = False
        cSQL = tcSQL
        cConnectionString = tcConnection
        Try
            loConnection = New OleDbConnection(tcConnection)
            loConnection.Open()
            oDataAdapter = New OleDbDataAdapter
            oDataAdapter.SelectCommand = New OleDbCommand(tcSQL, loConnection)
            oDataSet = New DataSet
            oDataAdapter.Fill(oDataSet, "Temp")
            llSuccess = True
        Catch loError As Exception
            cError = loError.Message
        End Try
        Return llSuccess
    End Function

End Class
